=== debian/changelog ===
xca (2.8.0-1) unstable; urgency=medium

  * Use Qt6 instead of Qt5.  Files changed:
    - d/control: Dependencies
  * New upstream release (2.8.0)

 -- Thomas Ward <teward@ubuntu.com>  Mon, 7 Jul 2024 16:30:00 -0400
