## xca 2.9.0

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -152,7 +152,7 @@
     endif()
 
   else()
-    message(WARNING "Application 'qhelpgenerator' not found. In-app documentation disabed.")
+    message(WARNING "Application 'qhelpgenerator' not found. In-app documentation disabled.")
   endif()
 else(SPHINX)
   message(WARNING "sphinx-build binary not found. Documentation generation disabled")
