=== lang/CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
   else()
     qt5_add_translation(QM_FILES ${TS_FILES} OPTIONS -silent)
   endif()
-  message(STATUS "Updating translations from source with 'lupdate' only supprted with QT6")
+  message(STATUS "Updating translations from source with 'lupdate' only supported with QT6")
   target_sources(${CMAKE_PROJECT_NAME} PRIVATE ${QM_FILES})
 else()
   get_target_property(LIBSRC xcalib SOURCES)
