=== debian/changelog ===
xca (2.9.0-1) unstable; urgency=medium

  * New upstream release (2.9.0) 

 -- Thomas Ward <teward@ubuntu.com>  Tue, 01 Jul 2025 18:41:57 -0400
